import { defineNuxtModule, createResolver, addComponent } from '@nuxt/kit';
import { readdirSync } from 'fs';

const module = defineNuxtModule({
  meta: {
    name: "nuxt-bootstrap-icons",
    configKey: "bootstrapIcons",
    compatibility: {
      nuxt: "^3.0.0"
    }
  },
  // Default configuration options of the Nuxt module
  defaults: { renderType: "inline" },
  async setup({ renderType }) {
    const { resolve } = createResolver(import.meta.url);
    if (renderType === "inline") {
      addComponent({
        filePath: resolve("./runtime/BootstrapIcon.vue"),
        name: "BootstrapIcon"
      });
    } else if (renderType === "component") {
      const components = readdirSync(
        resolve("./runtime/components")
      );
      for (const component of components) {
        addComponent({
          filePath: resolve("./runtime/components", component),
          name: `BootstrapIcon${component.split(".")[0]}`
        });
      }
    }
  }
});

export { module as default };
